/**
 * Dasu Project
 *
 * File:         NullReporter.java
 * RCS:          $Id$
 * Description:  NullReporter class (see below)
 * Author:       David Choffnes
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Jul 8, 2007 at 10:00:02 AM
 * Language:     Java
 * Package:      edu.northwestern.news.database
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2007, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.database;

import java.nio.charset.Charset;
import java.util.List;
import java.util.Map;

import edu.northwestern.dasu.measurement.TraceEntry;

/**
 * @author David Choffnes &lt;drchoffnes@cs.northwestern.edu&gt;
 *
 * The NullReporter class has all the methods of 
 * a database reporter, but does nothing. Useful for 
 * shutting down. 
 */
public class NullReporter implements DatabaseReporter {

	private static NullReporter instance = new NullReporter();
	
	public static DatabaseReporter getInstance(){
		return instance;
	}
	
	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#canConnect()
	 */
	public boolean canConnect() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#connect()
	 */
	public boolean connect() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#disconnect()
	 */
	public void disconnect() {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertDataTransferResult(long, int, byte, int, int, int, int, double, double)
	 */
	public boolean insertDataTransferResult(long time, int experimentId,
			byte type, int size, int sourceId, int destId, int currentId,
			double raceResultPrimary, double raceResultSecondary) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertDownloadStatDynamic(int, int, long, int, float, int, int, int, int, int, int, int, int, int)
	 */
	public boolean insertDownloadStatDynamic(int selfId, int downloadId,
			long timeRecorded, int numPeers, float availability, int completed,
			int discarded, int downloadRate, int uploadRate, int shareRatio,
			int numKnownNonSeeds, int numKnownSeeds, int state, int priority,
			long downloaded, long uploaded, int position, 
			int totalNumKnownNonSeeds, int totalNumKnownSeeds, long hashFails,
			int connectedSeeds, int connectedLeechers, long swarmPeerSpeed) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertDownloadStatSummary(int, int, long, long, long, int, int, long, long, long, long)
	 */
	public boolean insertDownloadStatSummary(int selfId, int downloadId,
			long currentTime, long downloadingTime, long seedingTime,
			int maxDownloadRateLimit, int maxUploadLimit, long totalUploaded,
			long totalDownloaded, long size, long pieceSize) {
		// TODO Auto-generated method stub
		return false;

	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertEvent(int, int, int, int, long, int)
	 */
	public boolean insertEvent(int customerId, int edgeId, int peerId,
			int eventType, long time, int timeZoneId) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertLocalPeerStatDynamic(int, long, int, int, int, int, boolean, int, int, int, int, int, int, int, int, int, int, long, long, long, long)
	 */
	public boolean insertLocalPeerStatDynamic(int selfId,
			long currentTime, int uploadRate, int downloadRate, 
			int maxDownloadRate, int maxUploadRate, boolean isAutoSpeed, int rst, 
			int numConnections, int passiveOpens, int activeOpens, int failedConns,
			int numTorrents, int numSeedingTorrents, int numLeechingTorents, 
			int numConnectedSeeds, int numConnectedLeechers,
			long bytesSentLpsd, long bytesReceivedLpsd, long bytesSentNetstat, long bytesReceivedNetstat, long swarmPeerSpeed,
			long numberOfActiveConnections, long totalBytesSent, long totalBytesReceived, long totalPacketsSent,
			long totalPacketsReceived, long uptime) {
		// TODO Auto-generated method stub
		return false;
	}


	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertLocalPeerStatStatic(int, long, int, int)
	 */
	public boolean insertLocalPeerStatStatic(int selfId, long uptime,
			int maxUploadRate, int maxDownloadRate) {
		// TODO Auto-generated method stub
		return false;

	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertRatio(long, int, double)
	 */
	public void insertRatio(long entryId, int edgeClusterId, double value) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertRatioEntry(int, int)
	 */
	public long insertRatioEntry(int myId, int customerId, int entries) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertRemotePeerStatDynamic(int, int, long, int, int, int, int, boolean, double, boolean, boolean)
	 */
	public boolean insertRemotePeerStatDynamic(int selfId, int peerId,
			long currentTime, int bytesReceivedFromPeer, int bytesSentToPeer,
			int currentReceiveRate, int currentSendRate, boolean isSeed,
			double ping, boolean isInterested, boolean isInteresting) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertRemotePeerStatStatic(int, int, int, long, int, int, boolean)
	 */
	public boolean insertRemotePeerStatStatic(int selfId, int peerId,
			int peerClient, long uptime, int tcpPort, int udpPort,
			boolean sameCluster, int type, String encryption, long pieceSize) {
		// TODO Auto-generated method stub
		return false;

	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertTraceEntry(int, int, long)
	 */
	public long insertTraceEntry(int sourceId, int destId, long time, int entries, int taskId) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#insertTraceEntryData(long, int[], edu.northwestern.news.experiment.TraceRouteRunner.TraceEntry)
	 */
	public boolean insertTraceEntryData(long entryId, int[] myRouterIds,
			TraceEntry te) {
		// TODO Auto-generated method stub
		return false;

	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#makeId(java.lang.String, java.lang.String, java.lang.String)
	 */
	public int makeId(String tableName, String colName, String value) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#registerUsage(int, long)
	 */
	public boolean registerUsage(int myId, long GMTTime, String uuid, long currentTime,
			String timeZone, boolean failed) {
		// TODO Auto-generated method stub
		return false;

	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#reportError(java.lang.Exception)
	 */
	public void reportError(Exception e) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#setExtendedConnection(boolean)
	 */
	public void setExtendedConnection(boolean extend) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see edu.northwestern.news.database.DatabaseReporter#stopReporting()
	 */
	public void stopReporting() {
		// TODO Auto-generated method stub

	}

	public void flush() {
		// TODO Auto-generated method stub
		
	}

	public Map<String, Integer> makeIdBatch(String tableName,
			String columnName, List<String> values) {
		// TODO Auto-generated method stub
		return null;
	}
	
	public void updateConfig(){
		
	}

	
	public void reportIpChange(int oldIp, int newIp, int localIp,
			long currentGMTTime) {
		// TODO Auto-generated method stub
		
	}


	public void insertAnomalyEvent(int selfId, long timeGMT,
			double stdDevThresh, int windowSize, int anomalyTypes,
			int uptime, float detectionProb) {
		// TODO Auto-generated method stub
		
	}


	public void insertAnomalyAlarm(int selfId, long timeGMT,
			double stdDevThresh, int windowSize, int numAnomalies,
			String region, int count, int anomalyType) {
		// TODO Auto-generated method stub
		
	}

	public boolean insertPingResultDasu(int destId, int sourceId, float rtt,
			long time, int destType, int taskId) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean insertHttpResultDasu(int sourceId, int urlId,  
    		double downloadDuration, double downloadSpeed, long time, 
    		int noBytes, int taskId) {
		// TODO Auto-generated method stub
		return false;
	}
	
	public boolean insertUpnpTestResult(int sourceId, long testTime, int port,
			String protocol, int success) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#getIspInfo(java.lang.String)
	 */
	public String getIspInfo(String myIp) {
		return null;		
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertUserReports(int, java.lang.String, java.lang.String)
	 */
	public boolean insertUserReports(int sourceId, String downloadIds,
			String comment) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertInterference(int, java.lang.String, long)
	 */
	public boolean insertInterference(int sourceId, String type, long timestamp) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertIspInfo(int, java.lang.String, java.lang.String)
	 */
	public boolean insertIspInfo(int sourceId, String prefix, String ispname, long timeRecorded) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertTask(int, long, int)
	 */
	public boolean insertTask(int sourceId, long timeStamp, int taskId) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertRSTStat(int, int, long, int, long, int, int, java.lang.String, java.lang.String, int, int, int, int)
	 */
	public boolean insertRSTStat(int sourceId, int destId, long downloadId,
			int numRst, long timeRecorded, int type, int port,
			String bitTorrentClient, String source, int isSeed, int amSeed,
			int numSeeds, int numPeers, String encryption) {

		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertInterferenceEvent(int, java.lang.String, long, int, int, int)
	 */
	public boolean insertInterferenceEvent(int sourceId, String type,
			long timestamp, long downloadId, long droppedTo, float mean) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertLocalPeerStatStatic(int, long, int, int, int, int, int, int, int, int, int, java.lang.String, int, int, int, int, int)
	 */
	public boolean insertLocalPeerStatStatic(int selfId, long uptime,
			int maxUploadRate, int maxDownloadRate,
			int maxPeerConnectionsGlobal, int maxPeerConnectionsPerTorrent,
			int maxPeerConnectionsPerTorrentSeeding, int maxUploadRateSeeding,
			int maxSeedsPerTorrent, int lazyBitfield, int requireEncryption,
			String encryptionMinLevel, int allowNonEncryptedOUT,
			int allowNonEncryptedIn, int useCryptoPortExtension, int tcpPortIn,
			int udpPortIn) {
		// TODO Auto-generated method stub
		return false;
		
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertRemotePeerConnectionStat(int, int, long, int, int, java.lang.String, int, int, int, int, java.lang.String)
	 */
	public boolean insertRemotePeerConnectionStat(int sourceId, int destId,
			long timeRecorded, int type, int port, String bitTorrentClient,
			int isSeed, int amSeed, int numSeeds, int numPeers,
			String encryptionLevel) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#getCanSendData()
	 */
	public boolean getCanSendData() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#getCurrentUrl()
	 */
	public String getCurrentUrl() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#getDefaultCharSet()
	 */
	public Charset getDefaultCharSet() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#getDefaultServer()
	 */
	public String getDefaultServer() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#isUseGzip()
	 */
	public boolean isUseGzip() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#setLastFailTime(long)
	 */
	public void setLastFailTime(long l) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#updateLastFailTime()
	 */
	public void updateLastFailTime() {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertSpeedTestResult(int, long, int, int, int, char, int, int)
	 */
	public boolean insertSpeedTestResult(int sourceId, long testTime,
			int downloadSpeed, int uploadSpeed, int encryption, char type,
			int downloadSpeedNetstat, int uploadSpeedNetstat) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertScrapeEntry(java.lang.String, java.lang.String, java.lang.String, int, int, int, long)
	 */
	public long insertScrapeEntry(String type, int peerId, String url, String hash, int entries,
			int numSeeds, int numLeechers, int taskId, long time) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertScrapeEntryData(long, long, int, int)
	 */
	public boolean insertScrapeEntryData(long entryId, int peerid, int tcp,
			int udp) {
		// TODO Auto-generated method stub
		return false;
		
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertDnsResult(int, int, long, long, java.lang.String, java.lang.String, java.lang.String, java.lang.String, boolean, long)
	 */
	public boolean insertDnsResult(int myId, int dnsId, long requestTime,
			long responseTime, String query, String type, String Options,
			String response, boolean failed, long taskId) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertDnsMapping(int, int, int, java.lang.String, int)
	 */
	public boolean insertDnsMapping(int myIp, int publicDns, int privateDns,
			String type, int order, long timeRecorded) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertNdtResultDasu(int, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, double, double, double, int, double, int, int, double, int, int, double, double, double, double, int, int, int, int, int, int, int, int, int, double, double, double, double, double, long, int, java.lang.String, double, double, double, int, int, int, int, double, int, int, int, double)
	 */
	public boolean insertNdtResultDasu(int myId, String osName, String osArch,
			String osVer, String interfaceName, String javaVer, String server,
			double rate, double rate2, double mylink, int mismatch,
			double avgrtt, int packetSize, int connectionStalledTimes,
			double connectionIdlePercentage, int packetQueuing,
			int packetQueuing2,
			double throughputPacketQueueingDetectedPercentage,
			double connectionReceiverLimitedPercentage,
			double connectionSenderLimitedPercentage,
			double connectionNetworkLimitedPercentage, int RFC2018, int RFC896,
			int RFC3168, int RFC1323TimeStamping, int RFC1323WindowScaling,
			int serverScalingFactor, int clientScalingFactor,
			int serverBehindFirewall, int clientBehindFirewall,
			double theoreticalNetworkLimit, double serverBuffer,
			double serverThroughputLimit, double clientBuffer,
			double clientThroughputLimit, long time, int failed,
			String errorMsg, double rateNetstat, double rateNetstat2,
			double networkFlowControlThroughputLimit, int congestion,
			int congestionSignals, int fastRetran, int timeouts,
			double outOfOrderPercentage, int pktsRetrans, int dupAcksIn,
			int ksRcvd, double packetLoss) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertStaticUPnPInfo(int, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String)
	 */
	public boolean insertStaticUPnPInfo(int myId, String UpstreamMaxBitRate,
			String DownstreamMaxBitRate, String NATEnabled,
			String Layer1UpstreamMaxBitRate, String Layer1DownstreamMaxBitRate,
			String PortMappingEnabled, String WANAccessType,
			String MaximumActiveConnections, String ExternalIPAddress) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertEventDasu(int, java.lang.String, long)
	 */
	public boolean insertConfigEventDasu(int sourceId, String event, long timestamp) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertFeedback(java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String)
	 */
	public boolean insertFeedback(String type, String name, String email, String message, String dump,
			long systime, long dasuGmtTime) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#insertDnsTimeout(int, int, long, long, int)
	 */
	public boolean insertDnsTimeout(int myDnsId, int myId, long startTime,
			long endTime, int giveUp) {
		// TODO Auto-generated method stub
		return false;
		
	}

	/* (non-Javadoc)
	 * @see edu.northwestern.dasu.database.DatabaseReporter#stop()
	 */
	public void stop() {
		// TODO Auto-generated method stub
		
	}

}
