package edu.northwestern.dasu.drools;

import org.xbill.DNS.Message;
import org.xbill.DNS.Record;
import org.xbill.DNS.Section;

import edu.northwestern.dasu.measurement.ProbeType;

public class FactDnsProbeResult extends FactProbeResult{
	
	String server = null;
	String toLookup = null;
	String options = null;
	Long requestTime = -1L;
	String type = null;
	Message response = null;
	Long responseTime = -1L;
	int taskId = -1;
	String simpleResponse = null;
	boolean failed = false;
	boolean timeout = false;

	public FactDnsProbeResult(String server, String toLookup, String options,
			Long requestTime, Message response, Long responseTime, String type, int taskId) {
		super(ProbeType.DNS);
		
		this.server = server;
		this.toLookup = toLookup;
		this.options = options;
		this.requestTime = requestTime;
		this.response = response;
		this.responseTime = responseTime;
		this.type = type;
		this.taskId = taskId;
		this.simpleResponse = getSimpleResponse();
	}

	public Message getResponse() {
		return null;
	}
	
	public String getSimpleResponse() {		
		
		Record[] rec = response.getSectionArray(Section.ANSWER);
		if (rec != null)
			try {
				return rec[0].rdataToString();
			}
			catch (Exception e) {
				
			}
		
		return "";
			
	}
	
	public Record[] readSection(int section) {				
		return response.getSectionArray(section);
	}
	
	public String getOptions() {
		return options;
	}
	
	public Message readMessage() {
		return response;
	}

	public void setResponse(Message response) {
		this.response = response;
	}

	public void setOptions(String options) {
		this.options = options;
	}

	public Long getRequestTime() {
		return requestTime;
	}

	public void setRequestTime(Long requestTime) {
		this.requestTime = requestTime;
	}

	public Long getResponseTime() {
		return responseTime;
	}

	public void setResponseTime(Long responseTime) {
		this.responseTime = responseTime;
	}

	public String getServer() {
		return server;
	}

	public void setServer(String server) {
		this.server = server;
	}
	
	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getToLookup() {
		return toLookup;
	}

	public void setToLookup(String toLookup) {
		this.toLookup = toLookup;
	}

	public int getTaskId() {
		return taskId;
	}

	public void setTaskId(int taskId) {
		this.taskId = taskId;
	}

	public void setSimpleResponse(String simpleResponse) {
		this.simpleResponse = simpleResponse;
	}

	public boolean isFailed() {
		return failed;
	}

	public void setFailed(boolean failed) {
		this.failed = failed;
	}

	/**
	 * @return Returns the timeout.
	 */
	public boolean isTimeout() {
		return timeout;
	}

	/**
	 * @param timeout The timeout to set.
	 */
	public void setTimeout(boolean timeout) {
		this.timeout = timeout;
	}

	
}
