package edu.northwestern.dasu.drools;

import edu.northwestern.dasu.measurement.TestType;
import edu.northwestern.dasu.util.Util;

public class FactForcedSeedingThroughPortTestResult extends FactTestResult {

	public long testStartTime;
	public long testEndTime;
	public boolean success = false;
	public long initialPort;
	public long tempPort;
	public String error = null;

	public FactForcedSeedingThroughPortTestResult() {
		super(TestType.FORCE_SEEDING_THROUGH_PORT);
		this.testEndTime = Util.currentGMTTime();
		
	}

	public FactForcedSeedingThroughPortTestResult(long startTime, 
			long initialPort, long tempPort, boolean success) {
		
		super(TestType.FORCE_SEEDING_THROUGH_PORT);
		this.testStartTime = startTime;
		this.initialPort = initialPort;
		this.tempPort = tempPort;
		this.success = success;
		this.testEndTime = Util.currentGMTTime();
	}

	public long getTestStartTime() {
		return testStartTime;
	}

	public long getTestEndTime() {
		return testEndTime;
	}

	public boolean isSuccess() {
		return success;
	}

	public long getInitialPort() {
		return initialPort;
	}

	public long getTempPort() {
		return tempPort;
	}

	public String getError() {
		return error;
	}

	public void setTestStartTime(long testStartTime) {
		this.testStartTime = testStartTime;
	}

	public void setTestEndTime(long testEndTime) {
		this.testEndTime = testEndTime;
	}

	public void setSuccess(boolean success) {
		this.success = success;
	}

	public void setInitialPort(long initialPort) {
		this.initialPort = initialPort;
	}

	public void setTempPort(long tempPort) {
		this.tempPort = tempPort;
	}

	public void setError(String error) {
		this.error = error;
	}

	
}
