/**
 * Dasu Project
 *
 * File:         FactMeasurementRst.java
 * RCS:          $Id$
 * Description:  FactMeasurementRst class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      May 31, 2010 at 5:20:20 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.drools
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2010, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

package edu.northwestern.dasu.drools;

import edu.northwestern.dasu.stats.RSTStat;

/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The FactMeasurementRst class ...
 */
public class FactMeasurementPeerRst extends FactMeasurement<RSTStat> {

		public long timeRecorded = -1;
		public long downloadId = -1;
		public String peerIp;
		public int port;
		public boolean isSeed;
		public String encryption;
		
		public FactMeasurementPeerRst() {
			
		}
		
		public FactMeasurementPeerRst(RSTStat rststat) {

			this.timeRecorded = rststat.timeRecorded;
			this.downloadId = rststat.downloadId;
			this.peerIp = rststat.peerIp;
			this.port = rststat.port;
			this.isSeed = rststat.isSeed;
			this.encryption = rststat.encryption;
			
		}

		public long getTimeRecorded() {
			return timeRecorded;
		}

		public long getDownloadId() {
			return downloadId;
		}

		public String getPeerIp() {
			return peerIp;
		}

		public int getPort() {
			return port;
		}

		public boolean isSeed() {
			return isSeed;
		}

		public String getEncryption() {
			return encryption;
		}

		public void setTimeRecorded(long timeRecorded) {
			this.timeRecorded = timeRecorded;
		}

		public void setDownloadId(long downloadId) {
			this.downloadId = downloadId;
		}

		public void setPeerIp(String peerIp) {
			this.peerIp = peerIp;
		}

		public void setPort(int port) {
			this.port = port;
		}

		public void setSeed(boolean isSeed) {
			this.isSeed = isSeed;
		}

		public void setEncryption(String encryption) {
			this.encryption = encryption;
		}


        
}
