package edu.northwestern.dasu.drools;

import edu.northwestern.dasu.measurement.TestType;
import edu.northwestern.dasu.util.Util;

public class FactUpnpTestResult extends FactTestResult {

	public Integer port = 1;
	public Boolean success = false;
	public String protocol = "tcp";
	public long testTime;
	public Boolean error = false;

	public FactUpnpTestResult() {
		super(TestType.AZUREUS_UPNP);
		this.testTime = Util.currentGMTTime();
	}

	public FactUpnpTestResult(Integer port, boolean sucess) {
		super(TestType.AZUREUS_UPNP);
		this.port = port;
		this.testTime = Util.currentGMTTime();
	}

	public FactUpnpTestResult(Integer port, boolean success, String protocol) {
		super(TestType.AZUREUS_UPNP);
		this.port = port;
		this.success = success;
		this.protocol = protocol;
		this.testTime = Util.currentGMTTime();
	}

	public FactUpnpTestResult(Integer port, boolean success, String protocol, boolean error) {
		super(TestType.AZUREUS_UPNP);
		this.port = port;
		this.success = success;
		this.protocol = protocol;
		this.error = error;
		this.testTime = Util.currentGMTTime();
	}

	public Integer getPort() {
		return port;
	}

	public Boolean getSuccess() {
		return success;
	}

	public String getProtocol() {
		return protocol;
	}

	public long getTestTime() {
		return testTime;
	}

	public Boolean getError() {
		return error;
	}

	public void setPort(Integer port) {
		this.port = port;
	}

	public void setSuccess(Boolean success) {
		this.success = success;
	}

	public void setProtocol(String protocol) {
		this.protocol = protocol;
	}

	public void setTestTime(long testTime) {
		this.testTime = testTime;
	}

	public void setError(Boolean error) {
		this.error = error;
	}

	
}
