package edu.northwestern.dasu.measurement;

import java.util.HashMap;
import org.gudy.azureus2.plugins.PluginInterface;
import org.gudy.azureus2.plugins.PluginListener;

import com.aelitis.azureus.plugins.upnp.UPnPMapping;
import com.aelitis.azureus.plugins.upnp.UPnPPlugin;

import edu.northwestern.pathload.PathloadSender;

public class PortManager {
	public PluginInterface pi_upnp;
	PluginInterface pi_az;
	HashMap<Integer,PluginListener> upnps;
	
	public PortManager(PluginInterface pi_az){
		this.pi_az = pi_az;
		this.pi_upnp = pi_az.getPluginManager().getPluginInterfaceByClass(UPnPPlugin.class);
		
		upnps = new HashMap<Integer,PluginListener>();
	}
	
	public boolean openPort(int portNumber){
				
		final int myPort = portNumber;

		if(!upnps.containsKey(portNumber)){
			PluginListener listener = new PluginListener(){
				
				public void
				initializationComplete()
				{
					UPnPMapping	upnp_mapping = ((UPnPPlugin)pi_upnp.getPlugin()).addMapping( 
						pi_az.getPluginName(), 
						true, 
						myPort, 
						true );
						
					UPnPMapping[] addresses = ((UPnPPlugin)pi_upnp.getPlugin()).getMappings();
						
			        pi_az.getUtilities().createThread("Pathload Sender", new PathloadSender());
				}
				
				public void closedownInitiated()
				{
				}
				
				public void
				closedownComplete()
				{
				}				
			};
			pi_az.addListener(listener);
			upnps.put(portNumber, listener);
			return true;
		} else { 
			return true;
		}
	}
	
	public void closePort(int portNumber){
		pi_az.removeListener(upnps.get(portNumber));
	}
}
