/**
 * Dasu Project
 *
 * File:         SignalHolder.java
 * RCS:          $Id: SignalHolder.java,v 1.0 Mar 10, 2011 4:59:34 PM Mario Exp $
 * Description:  SignalHolder class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Mar 10, 2011 at 4:59:34 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.measurement
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2011, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.measurement;

import java.util.ArrayList;
import java.util.LinkedList;

/**
 * Dasu Project
 *
 * File:         SignalHolder.java
 * RCS:          $Id: SignalHolder.java,v 1.0 Mar 10, 2011 4:59:34 PM Mario Exp $
 * Description:  SignalHolder class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Mar 10, 2011 at 4:59:34 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.measurement
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2011, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The SignalHolder class ...
 */
public class SessionSignalHolder {
	
	private LinkedList<Object> signal;
	private LinkedList<Long> time;
	private int size = -1;
	
	SessionSignalHolder(int size) {
		this.signal = new LinkedList<Object>();
		this.time = new LinkedList<Long>();
		this.size = size;
		for (int i=0; i<size; i++) {
			signal.add(-0f);
			time.add(-0l);
		}
		
	}

	public LinkedList<Object> getValues() {
		return signal;
	}
	
	public void set(Object f) {
		
		if ( signal.size() == size)
			signal.remove();
		
		signal.add(f);
		time.add(System.currentTimeMillis());
	}
	
	public LinkedList<Long> getTime() {
		return time;
	}
	
}
