/**
 * Dasu Project
 *
 * File:         IntervalType.java
 * RCS:          $Id$
 * Description:  IntervalType class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Oct 2, 2010 at 8:31:59 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.measurement
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2010, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.measurement;

/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The TimeType class ...
 */

public enum TimeType  { 
		
	SECOND(1), 
	MINUTE(1*60),
	HOUR(1*60*60),
	DAY(1*60*60*24),
	WEEK(1*60*60*24*7),
	MONTH(1*60*60*24*31),
	YEAR(1*60*60*24*365);

	private int val;
	
	private TimeType(int val) {
		this.val = val;
	}
	
	public int getVal() {
		return val;
	}
	
}