/**
 * Dasu Project
 *
 * File:         DownloadStats.java
 * RCS:          $Id$
 * Description:  DownloadStats class (see below)
 * Author:       David Choffnes
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Apr 10, 2007 at 1:39:15 PM
 * Language:     Java
 * Package:      edu.northwestern.news.stats
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2007, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.stats;

import com.azureus.plugins.aznetmon.main.RSTPacketStats;

import edu.northwestern.dasu.util.Util;

/**
 * @author Mario Sanchez &lt;msanchez@u.northwestern.edu&gt;
 * 
 */


public class RSTSystemStats implements Cloneable{
	
	public long timeRecorded;
	public int rst = -1;
	public int numConnections=-1;
	public int passiveOpens=-1;
	public int activeOpens=-1;
	public int failedConns=-1;

	public RSTSystemStats() {

		if (!RSTPacketStats.getInstance().getStatus().contains("only")) {
			
			timeRecorded = Util.currentGMTTime();
			rst = RSTPacketStats.getInstance().getMostRecent().nConnReset;
			numConnections = RSTPacketStats.getInstance().getMostRecent().nCurrentOpen;
			passiveOpens = RSTPacketStats.getInstance().getMostRecent().nPassiveOpens;
			activeOpens = RSTPacketStats.getInstance().getMostRecent().nActiveOpens;
			failedConns = RSTPacketStats.getInstance().getMostRecent().nFailedConnAttempt;
		}

	}
	
     public Object clone() {

    	 try {
              return super.clone();
          }
    	 catch( CloneNotSupportedException e ) {
              return null;
          }
      } 
	
}

