/**
 * Dasu Project
 *
 * File:         DownloadStats.java
 * RCS:          $Id$
 * Description:  DownloadStats class (see below)
 * Author:       David Choffnes
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Apr 10, 2007 at 1:39:15 PM
 * Language:     Java
 * Package:      edu.northwestern.news.stats
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2007, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.stats;

import edu.northwestern.dasu.util.Util;

/**
 * @author Mario Sanchez &lt;msanchez@u.northwestern.edu&gt;
 * 
 */


public class RemotePeerConnectionStat implements Cloneable{
	
	public long timeRecorded;
	public String peerIp;
	public int type;
	/* 0 Outgoing */
	/* 1 Incomming */
	public String bitTorrentClient;
	public int port;
	public boolean isSeed;
	public boolean amSeed;
	public int numSeeds;
	public int numPeers;
	public String encryption;
	

	public RemotePeerConnectionStat() {
		timeRecorded = Util.currentGMTTime();
	}
	
	public RemotePeerConnectionStat(String peerIp, long timeRecorded) {

		this.timeRecorded = timeRecorded;
		this.peerIp = peerIp;

	}
	
	public RemotePeerConnectionStat(String peerIp, long timeRecorded, String type, 
			int port, String bitTorrentClient, boolean isSeed, boolean amSeed,
			int numSeeds, int numPeers, String encryption) {

		this.peerIp = peerIp;
		this.timeRecorded = timeRecorded; 
		this.type = type.equals("Incoming")?1:0;
		this.bitTorrentClient = bitTorrentClient;
		this.port = port;
		this.isSeed = isSeed;
		this.amSeed = amSeed;
		this.numSeeds = numSeeds;
		this.numPeers = numPeers;
		this.encryption = encryption;

	}

	
     public Object clone() {

    	 try {
              return super.clone();
          }
    	 catch( CloneNotSupportedException e ) {
              return null;
          }
      } 
	
}

