/**
 * Dasu Project
 *
 * File:         OptimalEdgeServerExperimentManager.java
 * RCS:          $Id$
 * Description:  OptimalEdge class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Oct 15, 2008 at 07:38:30 PM
 * Language:     Java
 * Package:      edu.northwestern.ono.experiment
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2008, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.pathload;

/**
 * @author Mario Sanchez &lt;msanchez@u.northwestern.edu&gt;
 * 
 *         The PathloadManager class manages the Interference
 *         Test Experiment Set.
 **/

public class PathloadManager implements Runnable {	
	
	private static boolean isActive = true;
	private static PathloadManager self;
	private boolean DEBUG = true;

	//sleepInterval in minutes
	int sleepInterval = 30;
	//static OessDigger oessDig;
	static PathloadReceiver pathloadReceiver;
	static PathloadSender pathloadSender;
	public boolean pathloadFinished = false; 
	
	
	public PathloadManager() {
		super();
		self = this;
	}

	public static PathloadManager getInstance() {
		return self;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Runnable#run()
	 */

	public void run() {
	
		try {
			Thread.sleep(10*1000);
		} catch (InterruptedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		while (isActive) {
			
			//startPathloadReceiver("garganega");
			startPathloadSender();
			
			/*
			if (DEBUG) 
				System.out.println("HAMECAEXPERIMENTMANAGER: " +
						"start oessdigger?: " 
						+ HAMECAConfiguration.getInstance().isOessEnableExperiment() +
						", start oessExperiment? " 
						+ HAMECAConfiguration.getInstance().isOessEnableExperiment());
					

			if (HAMECAConfiguration.getInstance().isOessEnableDigger())
				startOessDigger();
			else
				if (oessDig != null)
					oessDig.setActive(false);
			
			if (HAMECAConfiguration.getInstance().isOessEnableExperiment() &&
					!oessExperimentFinished ) 
				startOessExperiment();			
			else 
				if (oessExperiment != null)
				oessExperiment.setActive(false);
			*/
			try {
				
				if (DEBUG)
					System.out.println("PathloadManager: sleeping for " + 
							sleepInterval + " minutes...");
				
				Thread.sleep(sleepInterval*60*1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	
	}
	
	protected void startPathloadReceiver(String sender) {
		if (pathloadReceiver == null) 
			pathloadReceiver = PathloadReceiver.getInstance(sender);
		
		if (!pathloadReceiver.isAlive()) 
			pathloadReceiver.start();
	}
	
	
	protected void startPathloadSender() {
		if (pathloadSender == null) 
			pathloadSender = PathloadSender.getInstance();
		
		if (!pathloadSender.isAlive()) 
			pathloadSender.start();
	}

		
	public static void stop() {
		isActive = false;
		if (pathloadReceiver != null) pathloadReceiver.setActive(false);
		self = null;	
		
	}

	

}
