window.log = function(msg, time) {
    if(time == undefined) {    
        time = new Date();
    }
    var el = document.createElement("li");
    el.innerHTML = time + ": " + msg;
    
    $("#log").prepend(el);
}

for(var i in logs) {
    log(logs[i][0], logs[i][1]);
}
errors = [];

function debug_jsonprint(obj, key, val) {
    $(obj).text(JSON.stringify(val));
}

function debug_monitorKey(key) {
    var li = document.createElement("li");
    li.appendChild(document.createTextNode(key + ": "));
    var sp = document.createElement("span");
    li.appendChild(sp);
    storage_register(key, sp, debug_jsonprint);
    $("#keys").append(li);
    // re-sort
    $("#keys li").sort(function(a, b) {return a.innerHTML > b.innerHTML ? 1 : -1;}).appendTo("#keys");
}

function logError(msg, url, line, time) {
    if(time == undefined) { time = new Date(); }

    if(window.storage_debug_updateKey != undefined && storage_debug_updateKey != null) {
        var contextMsg = "updating " + storage_debug_updateKey + " obj " + storage_debug_updateObj + " func " + storage_debug_updateFun;
        dasu_error(contextMsg, "-", "-");

        var el = document.createElement("li");
        el.innerHTML = time + " (context): " + contextMsg;
        
        $("#error").prepend(el);
    }

    dasu_error(msg, url, line);

    var el = document.createElement("li");
    el.innerHTML = time + " (" + url + ", Line " + line + "): " + msg;
    
    $("#error").prepend(el);
}

for(var i in errors) {
    logError(errors[i][0], errors[i][1], errors[i][2], errors[i][3]);
}
errors = [];

window.onerror = logError;

// If called after Dasu has been started, pull in all the keys to be monitored
for(key in storage_values) {
    debug_monitorKey(key);
}

$("#footer").append($("<br><input type=button value='Refresh' onclick='location.reload(true);'>"));

$("#storageDumpUpdate").button();
$("#storageDumpUpdate").click(function() {$("#storageDump").text(JSON.stringify(storage_values));});
$("#storageLoadUpdate").button();
$("#storageLoadUpdate").click(function() {
        var text = $("#storageLoad").val();
        var obj = JSON.parse(text);
        storage_reset();
        $("#keys").children().remove();
        
        storage_autoRegister();
        for(var key in obj) {
            storage_update(key, obj[key]);
        }
    });
